dpkg-buildpackage(1)

NAME
dpkg-buildpackage - build binary or source packages from sources

SYNOPSIS
dpkg-buildpackage [options]

DESCRIPTION
dpkg-buildpackage is a control script which can be used to help automate the building of a package.

OPTIONS

-b  Specifies a binary-only build, no source files are to be built and/or distributed.

-B  Specifies a binary-only build, no architecture independent binary package files are to be distributed either.

-S  Specifies a source-only build, no binary packages need to be made.

The -sx options control whether the original source archive is included in the upload if any source is being generated (i.e. -b or -B haven't been used).

-si By default, or if specified, the original source will be included if the version number ends in -0 or -1, i.e. if the Debian revision part of the version number is 0 or 1.

-sa Forces the inclusion of the original source.

-sd Forces the exclusion of the original source and includes only the diff.

-aarchitecture
    Specify the Debian architecture we build for. The architecture of the machine we build on is determined automatically, and is also the default for the host machine.

-vversion
    Use changelog information from all versions strictly later than version.

-Cchangesdescription
    Read the description of the changes from the file changesdescription rather than using the information from the source tree's changelog file.

-mmaintaineraddress
    Use maintaineraddress as the name and email address of the maintainer for this package, rather than using the information from the source tree's control file.

-emaintaineraddress
    Use maintaineraddress as the name and email address of the maintainer for this upload, rather than using the information from the source tree's changelog.

-D  Check build dependencies and conflicts; abort if unsatisfied.

-d  Do not check build dependencies and conflicts.

-W  Turn certain errors into warnings. Only dpkg-source uses this, but dpkg-buildpackage recognizes it, and passes it thru to dpkg-source.

-E  Negates a previously set -W. Only dpkg-source uses this, but dpkg-buildpackage recognizes it, and passes it thru to dpkg-source.

-nc Do not clean the source tree (implies -b).

-tc Clean the source tree (using gain-root-command debian/rules clean) after the package has been built.

-rgain-root-command
    When dpkg-buildpackage needs to execute part of the build process as root, it prefixes the command it executes with gain-root-command if one has been specified. gain-root-command should be the name of a program on the PATH and will get as arguments the name of the real command to run and the arguments it should take. gain-root-command should not contain spaces or any other shell metacharacters. gain-root-command might typically be fakeroot, sudo, super or really. su is not suitable, since it requires a -c option to run a command and even then it can only invoke the user's shell with -c instead of passing arguments individually to the command to be run.

-psign-command
    When dpkg-buildpackage needs to execute GPG or PGP to sign a source control (.dsc) file or a .changes file it will run sign-command (searching the PATH if necessary) instead of pgp. sign-command will get all the arguments that pgp would have gotten. If sign-command takes its arguments in GPG rather than PGP style, you should give the -sgpg option. sign-command should not contain spaces or any other shell metacharacters.

-kkey-id
    Specify a key-ID to use when signing packages.

-us Do not sign the source package.

-uc Do not sign the .changes file.

-i[regexp]
    Passed unchanged to dpkg-source.

-Ifilename
    Passed unchanged to dpkg-source. May be repeated multiple times.

--admindir=dir
    Change the location of the dpkg database. The default location is /var/lib/dpkg.

-h, --help
    Show the usage message and exit.

--version
    Show the version and exit.

BUGS
It should be possible to specify spaces and shell metacharacters in and initial arguments for gain-root-command and sign-command.

SEE ALSO
dpkg-source(1), dpkg-architecture(1), dpkg-genchanges(1), gpg(1), pgp(1).

AUTHORS
Copyright (C) 1995-1996 Ian Jackson
Copyright (C) 2000 Wichert Akkerman

This is free software; see the GNU General Public Licence version 2 or later for copying conditions. There is NO WARRANTY.